#*************************************************************
# Progamm:			fluisa_wlgl_inst_1d
# Sinn des Programms: 		Löser der instationären Wärmeleitungsgleichung 1d
# Sinn der Einheit  :		Ausgabe
# Name der Datei    :		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_inst_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				5
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.2018
# Letzte Änderung: 		28.01.2022
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os

#*************************************************************
# Import der Klasse matplotlib.pyplot für die Graphikausgabe
#*************************************************************
import matplotlib.pyplot as plt

class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")  

#*************************************************************
# Funktion zur Ausgabe in der Konsole
#*************************************************************
  def schirm_ausgabe(self,m,x,T_feld):
    print("Schirmaugabe")
    i_max = m - 1
    for i in range(i_max + 1):
      print ("%5i" %i,"%6.5f" %x[i], "%6.5f" %T_feld[0][i], "%6.5f" %T_feld[1][i], "%6.5f" %T_feld[2][i],"%6.5f" %T_feld[3][i],"%6.5f" %T_feld[4][i])


#*************************************************************
# Funktion zur Ausgabe in eine Datei
#*************************************************************
  def datei_ausgabe(self, ausgabe_datei, m, x, T_feld):
    i_max = m - 1
    fobj_out = open(ausgabe_datei,"w")
    for i in range(i_max + 1):
      fobj_out.write(str("%5i" %i))
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %x[i]))      
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %T_feld[0][i])) 
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %T_feld[1][i]))
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %T_feld[2][i]))
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %T_feld[3][i]))
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %T_feld[4][i]))      
      fobj_out.write("\n")
    fobj_out.close()


#*************************************************************
# Funktion zur graphischen Ausgabe
#*************************************************************
  def graphik_ausgabe_T(self,m, x, T, t,graphik_datei_wähler, zwischen_graphik_datei_anf, graphik_datei_format, graphik_titel):
    x_min=0.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    i_max = m - 1
    for i in range(i_max+1):
      if x_min >= x[i]:
        x_min = x[i]
      if x_max <= x[i]:
        x_max = x[i]
      if y_min >= T[i]:
        y_min = T[i]
      if y_max <= T[i]:
        y_max = T[i]
    #for i in range(i_max+1):
    plt.plot(x, T, 'r.')
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    x_min-=(x_max-x_min)/10.0
    x_max+=(x_max-x_min)/10.0
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title(graphik_titel + " " + str(t) +" Sekunden" )
    plt.xlabel("x [m]")
    plt.ylabel('Temperatur [K]')
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_wähler):
      graphik_datei_einzel = zwischen_graphik_datei_anf +"_" + str(t) +"_s." + graphik_datei_format
      plt.savefig(graphik_datei_einzel, format=graphik_datei_format)
    plt.show()

#*************************************************************
# Funktion zur graphischen Ausgabe für alle 4 Zeiten
#*************************************************************
  def graphik_ausgabe_T_alle_zeiten(self,m, x, T_feld, t_ausgabe_1, t_ausgabe_2,t_ausgabe_3, t_ausgabe_4, t_end, graphik_datei_wähler, graphik_datei, graphik_datei_format ):
    x_min=0.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    i_max = m - 1
# Hier Fehler: es müssen natürlich ALLE Ausgabezeiten überprüft werden!    
    for i in range(i_max+1):
      if x_min >= x[i]:
        x_min = x[i]
      if x_max <= x[i]:
        x_max = x[i]

    for j in range(5):
      for i in range(i_max+1):    
        if y_min >= T_feld[j][i]:
          y_min = T_feld[j][i]
        if y_max <= T_feld[j][i]:
          y_max = T_feld[j][i]
    #,label=r'numerische Lösung'
    #for i in range(i_max+1): 'b.',label=r'analytische Lösung' 
    plt.plot(x, T_feld[0], 'r.',label=r'T-Vert. bei '+str(t_ausgabe_1)+' s')
    plt.plot(x, T_feld[1], 'b.',label=r'T-Vert. bei '+str(t_ausgabe_2)+' s')
    plt.plot(x, T_feld[2], 'g.',label=r'T-Vert. bei '+str(t_ausgabe_3)+' s')
    plt.plot(x, T_feld[3], 'c.',label=r'T-Vert. bei '+str(t_ausgabe_4)+' s')
    plt.plot(x, T_feld[4], 'm.',label=r'T-Vert. bei '+str(t_end)+' s')
 # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    x_min-=(x_max-x_min)/2.5
    x_max+=(x_max-x_min)/2.5
    y_min-=(y_max-y_min)/2.5
    y_max+=(y_max-y_min)/2.5
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title("Temperaturverteilung zu verschiedenen Zeiten" )
    plt.xlabel("x [m]")
    plt.ylabel('Temperatur [K]')
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    # Diagramm speichern:
    if(graphik_datei_wähler):
      plt.savefig(graphik_datei + "." + graphik_datei_format, format = graphik_datei_format)
    plt.show()


