#*************************************************************
# Progamm:			fluisa_wlgl_stat_1d
# Sinn des Programms: 		Löser der stationären Wärmeleitungsgleichung
# Sinn der Einheit  :		Einlesen des Gitters
# Name dieser Datei    :	gitter.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_inst_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.2018
# Letzte Änderung: 		18.12.2022
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os
import pickle


import math
import numpy as np
#*************************************************************
# Klassendefinition Koeffizientenmatrix
#*************************************************************
class Gitter:
  #Konstruktormethode
  def __init__(self):		
    print("Gitterobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Gitterobjekt entfernt")   
    
    
#*************************************************************
# Funktion zum Einlesen des FVM-Gitters
#*************************************************************
  def gitter_input(self,gitter_datei, gitter_ascii_bin):
    self.rückgabeliste = list(range(2))
    self.rückgabeliste[0] = True                                   # Einlesen des Gitters korrekt            True/False
    self.rückgabeliste[1] = "Gitterdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen aus Gitterdatei  Text

    print("Einlesen des Gitters")    
    print("Name der Gitter_datei:",gitter_datei)
#*************************************************************
# Öffnung der Gitterdatei
#*************************************************************
    if os.path.exists(gitter_datei):
      print("Datei ist vorhanden")
      if gitter_ascii_bin == "a":
        fobj_in = open(gitter_datei,"r") 
#*************************************************************
# Einlesen der Anzahl der Gitterpunkte m
#*************************************************************
        zeile=fobj_in.readline()
        self.index = self.bool_function(zeile[:-1])
        if self.index:
          leseindex = 1
        else:
          leseindex = 0  
        zeile=fobj_in.readline()
        self.puffer = zeile[:-1]
        gitter_typ = self.puffer
        if gitter_typ == "v":
          zeile=fobj_in.readline()
          self.puffer = zeile[:-1]
          self.m=int(self.puffer)
          self.x =  np.zeros(self.m)
          self.delta_x = np.zeros(self.m-1)
          x_gf = np.zeros(self.m-1)
          self.A_gf = np.zeros(self.m-1)
          self.Delta_x =np.zeros(self.m-2)
          self.V = np.zeros(self.m-2)
#*************************************************************
# Einlesen der Knoten x[i]
#*************************************************************
          for i in range(self.m):
            zeile=fobj_in.readline()
            self.puffer = zeile[:-1]
            dummy   = self.puffer.split("\t")
            self.x[i]=float(dummy[leseindex])
 
#*************************************************************
# Einlesen der Knotenabstände delta_x[i]
#*************************************************************
          for i in range(self.m-1):
            zeile=fobj_in.readline()
            self.puffer = zeile[:-1]
            dummy   = self.puffer.split("\t")
            self.delta_x[i]=float(dummy[leseindex])
       
#*************************************************************
# Einlesen der Positionen der Grenzflächen der FV x_gf[i]
#*************************************************************
          for i in range(self.m-1):
            zeile=fobj_in.readline()
            self.puffer = zeile[:-1]
            dummy   = self.puffer.split("\t")
            x_gf[i]=float(dummy[leseindex])
        
#*************************************************************
# Einlesen der Inhalte der Grenzflächen der FV A_gf[i]
#*************************************************************
          for i in range(self.m-1):
            zeile=fobj_in.readline()
            self.puffer = zeile[:-1]
            dummy   = self.puffer.split("\t")
            self.A_gf[i]=float(dummy[leseindex])
       
#*************************************************************
# Einlesen der Abstände der Grenzflächen voneinander Delta_x[i]
#*************************************************************
          for i in range(self.m-2):
            zeile=fobj_in.readline()
            self.puffer = zeile[:-1]
            dummy   = self.puffer.split("\t")
            self.Delta_x[i]=float(dummy[leseindex])
        
#*************************************************************
# Einlesen der Volumina der FV V[i]
#*************************************************************
          for i in range(self.m-2):
            zeile=fobj_in.readline()
            self.puffer = zeile[:-1]
            dummy   = self.puffer.split("\t")
            self.V[i]=float(dummy[leseindex])
         
          fobj_in.close()
        elif gitter_typ == "d":
          print("Falscher Gittertyp, es wird ein Finite-Volumen-Gitter gebraucht") 
          self.rückgabeliste[0] = False
        else:
          print("Kein bekannter Gittertyp")  
          self.rückgabeliste[0] = False         
      elif gitter_ascii_bin == "b":
        fobj_in = open(gitter_datei,"rb")
        gitter_typ = pickle.load(fobj_in)
        if gitter_typ == "v":        
          self.m = pickle.load(fobj_in)
          self.x = pickle.load(fobj_in)
          self.delta_x = pickle.load(fobj_in)
          x_gf = pickle.load(fobj_in)
          self.A_gf = pickle.load(fobj_in)
          self.Delta_x = pickle.load(fobj_in)
          self.V = pickle.load(fobj_in) 
        elif gitter_typ == "d":
          print("Falscher Gittertyp, es wird ein Finite-Volumen-Gitter gebraucht") 
          self.rückgabeliste[0] = False          
        else:
          print("Kein bekannter Gittertyp")
          self.rückgabeliste[0] = False           
        fobj_in.close()
      else:
        print("Gitter weder ASCII noch binär")
        self.rückgabeliste[0] = False          
    else:
      print("Datei ist NICHT vorhanden")
      self.rückgabeliste[0] = False                                   # Einlesen des Gitters korrekt            True/False
      self.rückgabeliste[1] = "Gitterdatei nicht vorhanden!" 
    return self.rückgabeliste[0]
#*************************************************************
# Funktion zum Definieren von bool-Variablen
#*************************************************************
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return False

    
