#*************************************************************
# Progamm:			fluisa_wlgl_inst_1d
# Sinn des Programms: 		Löser der instationären Wärmeleitungsgleichung 1d
# Sinn der Einheit  :		Aufstellung der Koeffizientenmatrix
# Name der Datei    :		koeff_matrix.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_inst_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				5
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.2018
# Letzte Änderung: 		18.01.2023
#*************************************************************

#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os
import numpy as np
#*************************************************************
# Import der Klasse Steuer
#*************************************************************
from steuer import Steuer


import math

#*************************************************************
# Klassendefinition Koeffizientenmatrix
#*************************************************************
class Koeff_matrix:
  #Konstruktormethode
  def __init__(self):		
    print("Koeff_matrixobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Koeff_matrixobjekt entfernt")          

#*************************************************************
# Funktion zum Aufstellen der Koeffizientenmatrix
#*************************************************************

  def matrix(self,lambada,c,rho,delta_t,theta,m, delta_x, A_gf, Delta_x, rand_art, rand_wert):
    self.rückgabeliste = list(range(2))
    self.rückgabeliste[0] = True                                   # Erstellen der Koeffizientenmatrix korrekt   True/False
    self.rückgabeliste[1] = "Koeffizientenmatrix wurde erstellt"   # Fehlermeldung für Einlesen aus Gitterdatei  Text  
    try:
      print("Besetzung der Koeffizientenmatrix")
#*************************************************************
# Leider sieht Python für die Buchstabenfolge "lambda"
# etwas anderes vor. "lambda" ist aber das Kürzel für 
# die Wärmeleitfähigkeit.
# Wir fanden einen naheliegenden Ersatz: 
#*************************************************************
      self.c = c
      self.rho = rho
      self.a = lambada/c/rho
#*************************************************************
# Hier: a konst für alle FV
#*************************************************************
      self.ap = np.zeros(m)
      self.aw = np.zeros(m)
      self.ae = np.zeros(m)
      self.rtk = np.zeros(m)
      self.rtp = np.zeros(m)
      self.s = np.zeros(m)
    #innere Punkte
      for i in range(1,m-1):
        self.aw[i]=A_gf[i-1]*self.a/delta_x[i-1]*delta_t*theta
        self.ae[i]=A_gf[i]*self.a/delta_x[i]*delta_t*theta
        self.rtk[i]=0.0
        self.rtp[i]=0.0
      #  self.ap[i]=-(self.aw[i]+self.ae[i]+self.rtp[i])-A_gf[i-1]*Delta_x[i-1]
        self.ap[i]=-(self.aw[i]+self.ae[i]+self.rtp[i])-A_gf[i-1]*Delta_x[i-1]/c/rho  # Dimensionen! Überprüfen, ob Fehler behoben! 21.11.2022
    # Westrand Dirichlet
      if rand_art[0] == "d":
        print("Westrand: Dirichlet")
        T_A = rand_wert[0]
        self.aw[0]=0.0
        self.ae[0]=0.0
        self.rtk[0]=T_A
        self.rtp[0]=-1.0
        self.ap[0]=-(self.ae[0]+self.aw[0]+self.rtp[0])
    # Westrand von Neuman
      elif rand_art[0] == "n":
        print("Westrand: von Neumann")
        q_punkt_A = rand_wert[0]
        self.aw[0] = 0.0
        self.ae[0] = -lambada/delta_x[i]
        self.rtk[0] = q_punkt_A 
        self.rtp[0] = 0.0;
        self.ap[0] = -(self.ae[0]+self.aw[0]+self.rtp[0]); 
      
      else:
        print("Fehler in der West-Randbedingung!")
    # Ostrand Dirichlet
      if rand_art[1] == "d":
        print("Ostrand: Dirichlet")
        T_B = rand_wert[1]
        self.aw[m-1]=0.0
        self.ae[m-1]=0.0
        self.rtk[m-1]=T_B
        self.rtp[m-1]=-1.0
        self.ap[m-1]=-(self.ae[m-1]+self.aw[m-1]+self.rtp[m-1]) 
    # Ostrand von Neuman
      elif rand_art[1] == "n":
        print("Ostrand: von Neumann")
        q_punkt_B = rand_wert[1]
        self.aw[m-1]=lambada/delta_x[m-2]
        self.ae[m-1]=0.0
        self.rtk[m-1]=q_punkt_B 
        self.rtp[m-1]=0.0
        self.ap[m-1]=-(self.ae[m-1]+self.aw[m-1]+self.rtp[m-1])
      else:
        print("Fehler in der Ost-Randbedingung!")
    except:    
      self.rückgabeliste[0] = False                                   # Erstellen der Koeffizientenmatrix korrekt   True/False
      self.rückgabeliste[1] = "Fehler beim Erstellen der Koeffizientenmatrix."   # Fehlermeldung für Einlesen aus Gitterdatei  Tex
    return self.rückgabeliste[0]

    
 
  def T_initial(self,T_start, m):
    self.rückgabeliste_T_feld_initialisierung = list(range(2))
    self.rückgabeliste_T_feld_initialisierung[0] = True                                   # Erstellen der Koeffizientenmatrix korrekt   True/False
    self.rückgabeliste_T_feld_initialisierung[1] = "Initialisierung des T-Feldes  o.k." 
    try: 
      self.T = np.zeros(m+1)
      self.T_alt = np.zeros(m+1)
      for i in range(m):
        self.T[i] = T_start
        self.T_alt[i] = T_start
    except:
      self.rückgabeliste_T_feld_initialisierung[0] = False                                  # Erstellen der Koeffizientenmatrix korrekt   True/False
      self.rückgabeliste_T_feld_initialisierung[1] = "Fehler bei der Initialisierung des T-Feldes"           
    return True  


  def matrix_instationär(self, delta_t, theta,T_alt, m,delta_x, A_gf, V): #A_gf,Delta_x
    self.rückgabeliste_matrix_inst = list(range(2))
    self.rückgabeliste_matrix_inst[0] = True                                   # Erstellen der Koeffizientenmatrix korrekt   True/False
    self.rückgabeliste_matrix_inst[1] = "Instationärer Teil der Koeff_Matrix o.k."   # Fehlermeldung für Einlesen aus Gitterdatei  Text      
    try:
      for i in range(1,m-1):
        self.s[i] =  -A_gf[i-1]*self.a/delta_x[i-1]*delta_t*(1.0-theta)*T_alt[i-1] - A_gf[i]*self.a/delta_x[i]*delta_t*(1.0-theta)*T_alt[i+1]  \
        +((A_gf[i-1]/delta_x[i-1]+ A_gf[i]/delta_x[i])*self.a*delta_t*(1.0-theta) -V[i-1]/self.rho/self.c)*T_alt[i] + self.rtk[i] # Dimensionen! Überprüfen, ob Fehler behoben! 21.11.2022
      
      self.s[0] = 0.0 + self.rtk[0]
      self.s[m-1] = 0.0 + self.rtk[m-1]
    except:
      self.rückgabeliste_matrix_inst[0] = False                                   # Erstellen der Koeffizientenmatrix korrekt   True/False
      self.rückgabeliste_matrix_inst[1] = "Fehler beim Instationären Teil der Koeff_Matrix"       
    return  self.rückgabeliste_matrix_inst[0]


