#*************************************************************
# Progamm:			fluisa_wlgl_inst_1d
# Sinn des Programms: 		Löser der instationären Wärmeleitungsgleichung 1d
# Sinn der Einheit  :		Löser des GlS
# Name der Datei    :		loeser_lgs_3diag.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_inst_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	6
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			28.08.2019
# Letzte Änderung: 		15.01.2022
#*************************************************************


import math
import numpy as np

class Löser_lgs_3diag:
  #Konstruktormethode
  def __init__(self):		
    print("Löserobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Löserobjekt entfernt")  

#*************************************************************
# Deklarieren und Initialisieren der Felder im Löser
# eine derartige Trennung verhindert bie instationären Problemen,
# daß in einer Zeitschleife die Felder wiederholt deklariert und initialisiert werden.
#*************************************************************    
  def feld_init(self,m):
    self.rückgabeliste_feld_init = list(range(3))
    self.rückgabeliste_feld_init[0] = True                                      # Errechnen einer Lösung korrekt              True/False
    self.rückgabeliste_feld_init[1] = "Initialisierung des Phi-Feldes o.k."     # Fehlermeldung für Einlesen aus Gitterdatei  Text 
    #self.rückgabeliste_feld_init[2] = 0						# Anzahl der Iterationen 
    try:
      self.phi = np.zeros(m)

    except:
      self.rückgabeliste_feld_init[0] = False                                     # Errechnen einer Lösung korrekt              True/False
      self.rückgabeliste_feld_init[1] = "Fehler bei Initialisierung des Phi-Feldes"
    return self.rückgabeliste_feld_init[0]  
					# aw, ap, ae, rtk
  def gs_3diag(self,m, max_iter, eps, omega, resi_max, a, b, c, d, phi_init):
    phi_speicher_relax = 0.0
    resi = 0.0 
    iter = 0
    self.rückgabeliste = list(range(3))
    self.rückgabeliste[0] = True                        # Errechnen einer Lösung korrekt              True/False
    self.rückgabeliste[1] = "Lösung wurde errechnet"    # Fehlermeldung für Einlesen aus Gitterdatei  Text  
    try:
      for i in range(m):
        self.phi[i] = phi_init
      
      while iter <= max_iter and resi_max > eps: 
        resi_speicher = 0.0
      # Herausziehen aus der for-Schleife notwendig, da sonst bei self.phi[i] der Index [-1] im GS erreicht wird. Seltsamerweise keine Fehlermeldung dann!
        phi_speicher_relax = self.phi[0] 
        self.phi[0] = (d[0]-c[0]*self.phi[1])/b[0] 
        self.phi[0] = self.phi[0]*omega+phi_speicher_relax*(1.0-omega)
      
        resi = math.sqrt((self.phi[0]-phi_speicher_relax)*(self.phi[0]-phi_speicher_relax))  
        resi_speicher = resi
      
        for i in range(1,m-1):
          phi_speicher_relax = self.phi[i]
          self.phi[i]= (d[i]-(a[i]*self.phi[i-1]+c[i]*self.phi[i+1]))/b[i] 
          self.phi[i] = self.phi[i]*omega+phi_speicher_relax*(1.0-omega)
          resi=math.sqrt((self.phi[i]-phi_speicher_relax)*(self.phi[i]-phi_speicher_relax)) 
        
          if (resi > resi_speicher):  
            resi_speicher = resi
          
      # Herausziehen aus der for-Schleife notwendig, da sonst bei self.phi[i] der Index [m] im GS erreicht wird.  
        phi_speicher_relax = self.phi[m-1]
        self.phi[m-1]= (d[m-1]-a[m-1]*self.phi[m-2])/b[m-1]
        self.phi[m-1] = self.phi[m-1]*omega+phi_speicher_relax*(1.0-omega)    
        resi=math.sqrt((self.phi[m-1]-phi_speicher_relax)*(self.phi[m-1]-phi_speicher_relax)) 
      
        if (resi > resi_speicher):  
          resi_speicher = resi
          
        resi_max = resi_speicher 
#        if resi_max <= eps:
#          break   	
        iter+=1

      if iter >= max_iter:
        self.rückgabeliste[0] = False                        # Errechnen einer Lösung korrekt              True/False
        self.rückgabeliste[1] = "Löser konvergierte nicht" 
      self.rückgabeliste[2] = iter        
    except:
      self.rückgabeliste[0] = False                        # Errechnen einer Lösung korrekt              True/False
      self.rückgabeliste[1] = "Lösung wurde nicht errechnet"    # Fehlermeldung für Einlesen aus Gitterdatei  Text        
      
    return self.rückgabeliste[0]
